Linux Audio

Check our new training course

Loading...
v5.4
  1#!/bin/bash
  2# SPDX-License-Identifier: GPL-2.0
  3# Linux kernel coccicheck
  4#
  5# Read Documentation/dev-tools/coccinelle.rst
  6#
  7# This script requires at least spatch
  8# version 1.0.0-rc11.
  9
 10DIR="$(dirname $(readlink -f $0))/.."
 11SPATCH="`which ${SPATCH:=spatch}`"
 12
 13if [ ! -x "$SPATCH" ]; then
 14    echo 'spatch is part of the Coccinelle project and is available at http://coccinelle.lip6.fr/'
 15    exit 1
 16fi
 17
 18SPATCH_VERSION=$($SPATCH --version | head -1 | awk '{print $3}')
 19SPATCH_VERSION_NUM=$(echo $SPATCH_VERSION | ${DIR}/scripts/ld-version.sh)
 20
 21USE_JOBS="no"
 22$SPATCH --help | grep "\-\-jobs" > /dev/null && USE_JOBS="yes"
 23
 24# The verbosity may be set by the environmental parameter V=
 25# as for example with 'make V=1 coccicheck'
 26
 27if [ -n "$V" -a "$V" != "0" ]; then
 28	VERBOSE="$V"
 29else
 30	VERBOSE=0
 31fi
 32
 33FLAGS="--very-quiet"
 34
 35# You can use SPFLAGS to append extra arguments to coccicheck or override any
 36# heuristics done in this file as Coccinelle accepts the last options when
 37# options conflict.
 38#
 39# A good example for use of SPFLAGS is if you want to debug your cocci script,
 40# you can for instance use the following:
 41#
 42# $ export COCCI=scripts/coccinelle/misc/irqf_oneshot.cocci
 43# $ make coccicheck MODE=report DEBUG_FILE="all.err" SPFLAGS="--profile --show-trying" M=./drivers/mfd/arizona-irq.c
 44#
 45# "--show-trying" should show you what rule is being processed as it goes to
 46# stdout, you do not need a debug file for that. The profile output will be
 47# be sent to stdout, if you provide a DEBUG_FILE the profiling data can be
 48# inspected there.
 49#
 50# --profile will not output if --very-quiet is used, so avoid it.
 51echo $SPFLAGS | egrep -e "--profile|--show-trying" 2>&1 > /dev/null
 52if [ $? -eq 0 ]; then
 53	FLAGS="--quiet"
 54fi
 55
 56# spatch only allows include directories with the syntax "-I include"
 57# while gcc also allows "-Iinclude" and "-include include"
 58COCCIINCLUDE=${LINUXINCLUDE//-I/-I }
 59COCCIINCLUDE=${COCCIINCLUDE// -include/ --include}
 60
 61if [ "$C" = "1" -o "$C" = "2" ]; then
 62    ONLINE=1
 63
 
 
 
 
 
 
 
 
 
 
 
 
 64    # Take only the last argument, which is the C file to test
 65    shift $(( $# - 1 ))
 66    OPTIONS="$COCCIINCLUDE $1"
 67
 68    # No need to parallelize Coccinelle since this mode takes one input file.
 69    NPROC=1
 70else
 71    ONLINE=0
 72    if [ "$KBUILD_EXTMOD" = "" ] ; then
 73        OPTIONS="--dir $srctree $COCCIINCLUDE"
 74    else
 75        OPTIONS="--dir $KBUILD_EXTMOD $COCCIINCLUDE"
 76    fi
 77
 
 
 78    if [ -z "$J" ]; then
 79        NPROC=$(getconf _NPROCESSORS_ONLN)
 
 
 
 80    else
 81        NPROC="$J"
 82    fi
 83fi
 84
 85if [ "$KBUILD_EXTMOD" != "" ] ; then
 86    OPTIONS="--patch $srctree $OPTIONS"
 87fi
 88
 89# You can override by using SPFLAGS
 90if [ "$USE_JOBS" = "no" ]; then
 91	trap kill_running SIGTERM SIGINT
 92	declare -a SPATCH_PID
 93elif [ "$NPROC" != "1" ]; then
 94	# Using 0 should work as well, refer to _SC_NPROCESSORS_ONLN use on
 95	# https://github.com/rdicosmo/parmap/blob/master/setcore_stubs.c
 96	OPTIONS="$OPTIONS --jobs $NPROC --chunksize 1"
 97fi
 98
 99if [ "$MODE" = "" ] ; then
100    if [ "$ONLINE" = "0" ] ; then
101	echo 'You have not explicitly specified the mode to use. Using default "report" mode.'
102	echo 'Available modes are the following: patch, report, context, org'
103	echo 'You can specify the mode with "make coccicheck MODE=<mode>"'
104	echo 'Note however that some modes are not implemented by some semantic patches.'
105    fi
106    MODE="report"
107fi
108
109if [ "$MODE" = "chain" ] ; then
110    if [ "$ONLINE" = "0" ] ; then
111	echo 'You have selected the "chain" mode.'
112	echo 'All available modes will be tried (in that order): patch, report, context, org'
113    fi
114elif [ "$MODE" = "report" -o "$MODE" = "org" ] ; then
115    FLAGS="--no-show-diff $FLAGS"
116fi
117
118if [ "$ONLINE" = "0" ] ; then
119    echo ''
120    echo 'Please check for false positives in the output before submitting a patch.'
121    echo 'When using "patch" mode, carefully review the patch before submitting it.'
122    echo ''
123fi
124
125run_cmd_parmap() {
126	if [ $VERBOSE -ne 0 ] ; then
127		echo "Running ($NPROC in parallel): $@"
128	fi
129	echo $@ >>$DEBUG_FILE
130	$@ 2>>$DEBUG_FILE
 
 
 
 
 
 
131	err=$?
132	if [[ $err -ne 0 ]]; then
133		echo "coccicheck failed"
134		exit $err
135	fi
136}
137
138run_cmd_old() {
139	local i
140	if [ $VERBOSE -ne 0 ] ; then
141		echo "Running ($NPROC in parallel): $@"
142	fi
143	for i in $(seq 0 $(( NPROC - 1)) ); do
144		eval "$@ --max $NPROC --index $i &"
145		SPATCH_PID[$i]=$!
146		if [ $VERBOSE -eq 2 ] ; then
147			echo "${SPATCH_PID[$i]} running"
148		fi
149	done
150	wait
151}
152
153run_cmd() {
154	if [ "$USE_JOBS" = "yes" ]; then
155		run_cmd_parmap $@
156	else
157		run_cmd_old $@
158	fi
159}
160
161kill_running() {
162	for i in $(seq 0 $(( NPROC - 1 )) ); do
163		if [ $VERBOSE -eq 2 ] ; then
164			echo "Killing ${SPATCH_PID[$i]}"
165		fi
166		kill ${SPATCH_PID[$i]} 2>/dev/null
167	done
168}
169
170# You can override heuristics with SPFLAGS, these must always go last
171OPTIONS="$OPTIONS $SPFLAGS"
172
173coccinelle () {
174    COCCI="$1"
175
176    OPT=`grep "Options:" $COCCI | cut -d':' -f2`
177    REQ=`grep "Requires:" $COCCI | cut -d':' -f2 | sed "s| ||"`
178    REQ_NUM=$(echo $REQ | ${DIR}/scripts/ld-version.sh)
179    if [ "$REQ_NUM" != "0" ] ; then
180	    if [ "$SPATCH_VERSION_NUM" -lt "$REQ_NUM" ] ; then
181		    echo "Skipping coccinelle SmPL patch: $COCCI"
182		    echo "You have coccinelle:           $SPATCH_VERSION"
183		    echo "This SmPL patch requires:      $REQ"
184		    return
185	    fi
186    fi
187
188#   The option '--parse-cocci' can be used to syntactically check the SmPL files.
189#
190#    $SPATCH -D $MODE $FLAGS -parse_cocci $COCCI $OPT > /dev/null
191
192    if [ $VERBOSE -ne 0 -a $ONLINE -eq 0 ] ; then
193
194	FILE=${COCCI#$srctree/}
195
196	echo "Processing `basename $COCCI`"
197	echo "with option(s) \"$OPT\""
198	echo ''
199	echo 'Message example to submit a patch:'
200
201	sed -ne 's|^///||p' $COCCI
202
203	if [ "$MODE" = "patch" ] ; then
204	    echo ' The semantic patch that makes this change is available'
205	elif [ "$MODE" = "report" ] ; then
206	    echo ' The semantic patch that makes this report is available'
207	elif [ "$MODE" = "context" ] ; then
208	    echo ' The semantic patch that spots this code is available'
209	elif [ "$MODE" = "org" ] ; then
210	    echo ' The semantic patch that makes this Org report is available'
211	else
212	    echo ' The semantic patch that makes this output is available'
213	fi
214	echo " in $FILE."
215	echo ''
216	echo ' More information about semantic patching is available at'
217	echo ' http://coccinelle.lip6.fr/'
218	echo ''
219
220	if [ "`sed -ne 's|^//#||p' $COCCI`" ] ; then
221	    echo 'Semantic patch information:'
222	    sed -ne 's|^//#||p' $COCCI
223	    echo ''
224	fi
225    fi
226
227    if [ "$MODE" = "chain" ] ; then
228	run_cmd $SPATCH -D patch   \
229		$FLAGS --cocci-file $COCCI $OPT $OPTIONS               || \
230	run_cmd $SPATCH -D report  \
231		$FLAGS --cocci-file $COCCI $OPT $OPTIONS --no-show-diff || \
232	run_cmd $SPATCH -D context \
233		$FLAGS --cocci-file $COCCI $OPT $OPTIONS               || \
234	run_cmd $SPATCH -D org     \
235		$FLAGS --cocci-file $COCCI $OPT $OPTIONS --no-show-diff || exit 1
236    elif [ "$MODE" = "rep+ctxt" ] ; then
237	run_cmd $SPATCH -D report  \
238		$FLAGS --cocci-file $COCCI $OPT $OPTIONS --no-show-diff && \
239	run_cmd $SPATCH -D context \
240		$FLAGS --cocci-file $COCCI $OPT $OPTIONS || exit 1
241    else
242	run_cmd $SPATCH -D $MODE   $FLAGS --cocci-file $COCCI $OPT $OPTIONS || exit 1
243    fi
244
245}
246
247if [ "$DEBUG_FILE" != "/dev/null" -a "$DEBUG_FILE" != "" ]; then
248	if [ -f $DEBUG_FILE ]; then
249		echo "Debug file $DEBUG_FILE exists, bailing"
250		exit
251	fi
252else
253	DEBUG_FILE="/dev/null"
254fi
255
256if [ "$COCCI" = "" ] ; then
257    for f in `find $srctree/scripts/coccinelle/ -name '*.cocci' -type f | sort`; do
258	coccinelle $f
259    done
260else
261    coccinelle $COCCI
262fi
v6.2
  1#!/bin/bash
  2# SPDX-License-Identifier: GPL-2.0
  3# Linux kernel coccicheck
  4#
  5# Read Documentation/dev-tools/coccinelle.rst
  6#
  7# This script requires at least spatch
  8# version 1.0.0-rc11.
  9
 10DIR="$(dirname $(readlink -f $0))/.."
 11SPATCH="`which ${SPATCH:=spatch}`"
 12
 13if [ ! -x "$SPATCH" ]; then
 14    echo 'spatch is part of the Coccinelle project and is available at http://coccinelle.lip6.fr/'
 15    exit 1
 16fi
 17
 18SPATCH_VERSION=$($SPATCH --version | head -1 | awk '{print $3}')
 
 19
 20USE_JOBS="no"
 21$SPATCH --help | grep "\-\-jobs" > /dev/null && USE_JOBS="yes"
 22
 23# The verbosity may be set by the environmental parameter V=
 24# as for example with 'make V=1 coccicheck'
 25
 26if [ -n "$V" -a "$V" != "0" ]; then
 27	VERBOSE="$V"
 28else
 29	VERBOSE=0
 30fi
 31
 32FLAGS="--very-quiet"
 33
 34# You can use SPFLAGS to append extra arguments to coccicheck or override any
 35# heuristics done in this file as Coccinelle accepts the last options when
 36# options conflict.
 37#
 38# A good example for use of SPFLAGS is if you want to debug your cocci script,
 39# you can for instance use the following:
 40#
 41# $ export COCCI=scripts/coccinelle/misc/irqf_oneshot.cocci
 42# $ make coccicheck MODE=report DEBUG_FILE="all.err" SPFLAGS="--profile --show-trying" M=./drivers/mfd/arizona-irq.c
 43#
 44# "--show-trying" should show you what rule is being processed as it goes to
 45# stdout, you do not need a debug file for that. The profile output will be
 46# be sent to stdout, if you provide a DEBUG_FILE the profiling data can be
 47# inspected there.
 48#
 49# --profile will not output if --very-quiet is used, so avoid it.
 50echo $SPFLAGS | grep -E -e "--profile|--show-trying" 2>&1 > /dev/null
 51if [ $? -eq 0 ]; then
 52	FLAGS="--quiet"
 53fi
 54
 55# spatch only allows include directories with the syntax "-I include"
 56# while gcc also allows "-Iinclude" and "-include include"
 57COCCIINCLUDE=${LINUXINCLUDE//-I/-I }
 58COCCIINCLUDE=${COCCIINCLUDE// -include/ --include}
 59
 60if [ "$C" = "1" -o "$C" = "2" ]; then
 61    ONLINE=1
 62
 63    if [[ $# -le 0 ]]; then
 64	    echo ''
 65	    echo 'Specifying both the variable "C" and rule "coccicheck" in the make
 66command results in a shift count error.'
 67	    echo ''
 68	    echo 'Try specifying "scripts/coccicheck" as a value for the CHECK variable instead.'
 69	    echo ''
 70	    echo 'Example:	make C=2 CHECK=scripts/coccicheck drivers/net/ethernet/ethoc.o'
 71	    echo ''
 72	    exit 1
 73    fi
 74
 75    # Take only the last argument, which is the C file to test
 76    shift $(( $# - 1 ))
 77    OPTIONS="$COCCIINCLUDE $1"
 78
 79    # No need to parallelize Coccinelle since this mode takes one input file.
 80    NPROC=1
 81else
 82    ONLINE=0
 83    if [ "$KBUILD_EXTMOD" = "" ] ; then
 84        OPTIONS="--dir $srctree $COCCIINCLUDE"
 85    else
 86        OPTIONS="--dir $KBUILD_EXTMOD $COCCIINCLUDE"
 87    fi
 88
 89    # Use only one thread per core by default if hyperthreading is enabled
 90    THREADS_PER_CORE=$(LANG=C lscpu | grep "Thread(s) per core: " | tr -cd "[:digit:]")
 91    if [ -z "$J" ]; then
 92        NPROC=$(getconf _NPROCESSORS_ONLN)
 93	if [ $THREADS_PER_CORE -gt 1 -a $NPROC -gt 4 ] ; then
 94		NPROC=$((NPROC/2))
 95	fi
 96    else
 97        NPROC="$J"
 98    fi
 99fi
100
101if [ "$KBUILD_EXTMOD" != "" ] ; then
102    OPTIONS="--patch $srctree $OPTIONS"
103fi
104
105# You can override by using SPFLAGS
106if [ "$USE_JOBS" = "no" ]; then
107	trap kill_running SIGTERM SIGINT
108	declare -a SPATCH_PID
109elif [ "$NPROC" != "1" ]; then
110	# Using 0 should work as well, refer to _SC_NPROCESSORS_ONLN use on
111	# https://github.com/rdicosmo/parmap/blob/master/setcore_stubs.c
112	OPTIONS="$OPTIONS --jobs $NPROC --chunksize 1"
113fi
114
115if [ "$MODE" = "" ] ; then
116    if [ "$ONLINE" = "0" ] ; then
117	echo 'You have not explicitly specified the mode to use. Using default "report" mode.'
118	echo 'Available modes are the following: patch, report, context, org, chain'
119	echo 'You can specify the mode with "make coccicheck MODE=<mode>"'
120	echo 'Note however that some modes are not implemented by some semantic patches.'
121    fi
122    MODE="report"
123fi
124
125if [ "$MODE" = "chain" ] ; then
126    if [ "$ONLINE" = "0" ] ; then
127	echo 'You have selected the "chain" mode.'
128	echo 'All available modes will be tried (in that order): patch, report, context, org'
129    fi
130elif [ "$MODE" = "report" -o "$MODE" = "org" ] ; then
131    FLAGS="--no-show-diff $FLAGS"
132fi
133
134if [ "$ONLINE" = "0" ] ; then
135    echo ''
136    echo 'Please check for false positives in the output before submitting a patch.'
137    echo 'When using "patch" mode, carefully review the patch before submitting it.'
138    echo ''
139fi
140
141run_cmd_parmap() {
142	if [ $VERBOSE -ne 0 ] ; then
143		echo "Running ($NPROC in parallel): $@"
144	fi
145	if [ "$DEBUG_FILE" != "/dev/null" -a "$DEBUG_FILE" != "" ]; then
146                echo $@>>$DEBUG_FILE
147                $@ 2>>$DEBUG_FILE
148        else
149                echo $@
150                $@ 2>&1
151	fi
152
153	err=$?
154	if [[ $err -ne 0 ]]; then
155		echo "coccicheck failed"
156		exit $err
157	fi
158}
159
160run_cmd_old() {
161	local i
162	if [ $VERBOSE -ne 0 ] ; then
163		echo "Running ($NPROC in parallel): $@"
164	fi
165	for i in $(seq 0 $(( NPROC - 1)) ); do
166		eval "$@ --max $NPROC --index $i &"
167		SPATCH_PID[$i]=$!
168		if [ $VERBOSE -eq 2 ] ; then
169			echo "${SPATCH_PID[$i]} running"
170		fi
171	done
172	wait
173}
174
175run_cmd() {
176	if [ "$USE_JOBS" = "yes" ]; then
177		run_cmd_parmap $@
178	else
179		run_cmd_old $@
180	fi
181}
182
183kill_running() {
184	for i in $(seq 0 $(( NPROC - 1 )) ); do
185		if [ $VERBOSE -eq 2 ] ; then
186			echo "Killing ${SPATCH_PID[$i]}"
187		fi
188		kill ${SPATCH_PID[$i]} 2>/dev/null
189	done
190}
191
192# You can override heuristics with SPFLAGS, these must always go last
193OPTIONS="$OPTIONS $SPFLAGS"
194
195coccinelle () {
196    COCCI="$1"
197
198    OPT=`grep "Options:" $COCCI | cut -d':' -f2`
199    REQ=`grep "Requires:" $COCCI | cut -d':' -f2 | sed "s| ||"`
200    if [ -n "$REQ" ] && ! { echo "$REQ"; echo "$SPATCH_VERSION"; } | sort -CV ; then
201	    echo "Skipping coccinelle SmPL patch: $COCCI"
202	    echo "You have coccinelle:           $SPATCH_VERSION"
203	    echo "This SmPL patch requires:      $REQ"
204	    return
 
 
 
205    fi
206
207#   The option '--parse-cocci' can be used to syntactically check the SmPL files.
208#
209#    $SPATCH -D $MODE $FLAGS -parse_cocci $COCCI $OPT > /dev/null
210
211    if [ $VERBOSE -ne 0 -a $ONLINE -eq 0 ] ; then
212
213	FILE=${COCCI#$srctree/}
214
215	echo "Processing `basename $COCCI`"
216	echo "with option(s) \"$OPT\""
217	echo ''
218	echo 'Message example to submit a patch:'
219
220	sed -ne 's|^///||p' $COCCI
221
222	if [ "$MODE" = "patch" ] ; then
223	    echo ' The semantic patch that makes this change is available'
224	elif [ "$MODE" = "report" ] ; then
225	    echo ' The semantic patch that makes this report is available'
226	elif [ "$MODE" = "context" ] ; then
227	    echo ' The semantic patch that spots this code is available'
228	elif [ "$MODE" = "org" ] ; then
229	    echo ' The semantic patch that makes this Org report is available'
230	else
231	    echo ' The semantic patch that makes this output is available'
232	fi
233	echo " in $FILE."
234	echo ''
235	echo ' More information about semantic patching is available at'
236	echo ' http://coccinelle.lip6.fr/'
237	echo ''
238
239	if [ "`sed -ne 's|^//#||p' $COCCI`" ] ; then
240	    echo 'Semantic patch information:'
241	    sed -ne 's|^//#||p' $COCCI
242	    echo ''
243	fi
244    fi
245
246    if [ "$MODE" = "chain" ] ; then
247	run_cmd $SPATCH -D patch   \
248		$FLAGS --cocci-file $COCCI $OPT $OPTIONS               || \
249	run_cmd $SPATCH -D report  \
250		$FLAGS --cocci-file $COCCI $OPT $OPTIONS --no-show-diff || \
251	run_cmd $SPATCH -D context \
252		$FLAGS --cocci-file $COCCI $OPT $OPTIONS               || \
253	run_cmd $SPATCH -D org     \
254		$FLAGS --cocci-file $COCCI $OPT $OPTIONS --no-show-diff || exit 1
255    elif [ "$MODE" = "rep+ctxt" ] ; then
256	run_cmd $SPATCH -D report  \
257		$FLAGS --cocci-file $COCCI $OPT $OPTIONS --no-show-diff && \
258	run_cmd $SPATCH -D context \
259		$FLAGS --cocci-file $COCCI $OPT $OPTIONS || exit 1
260    else
261	run_cmd $SPATCH -D $MODE   $FLAGS --cocci-file $COCCI $OPT $OPTIONS || exit 1
262    fi
263
264}
265
266if [ "$DEBUG_FILE" != "/dev/null" -a "$DEBUG_FILE" != "" ]; then
267	if [ -f $DEBUG_FILE ]; then
268		echo "Debug file $DEBUG_FILE exists, bailing"
269		exit
270	fi
271else
272	DEBUG_FILE="/dev/null"
273fi
274
275if [ "$COCCI" = "" ] ; then
276    for f in `find $srctree/scripts/coccinelle/ -name '*.cocci' -type f | sort`; do
277	coccinelle $f
278    done
279else
280    coccinelle $COCCI
281fi